Index: utils/copix/smarty_plugins/function.csv.php
===================================================================
RCS file: /cvsroot/copix/Copix2/utils/copix/smarty_plugins/function.csv.php,v
retrieving revision 1.3
diff -u -r1.3 function.csv.php
--- utils/copix/smarty_plugins/function.csv.php	24 Feb 2005 17:29:33 -0000	1.3
+++ utils/copix/smarty_plugins/function.csv.php	18 Jun 2005 01:09:34 -0000
@@ -3,7 +3,7 @@
 * @package   copix
 * @subpackage SmartyPlugins
 * @version   $Id: function.csv.php,v 1.3 2005/02/24 17:29:33 sdaclin Exp $
-* @author   Daclin Sylvain
+* @author   Daclin Sylvain and Rahal Aboulfeth
 *           see copix.aston.fr for other contributors.
 * @copyright 2001-2005 CopixTeam
 * @link      http://copix.aston.fr
@@ -21,7 +21,9 @@
 *           separator        = (optional) the separator for the csv file. (default is "," [comma])
 *           displayHeaders   = (optional) if we wants to output the headers
 * Examples:
-* {csv values=$arObjects displayHeaders=false order=$array displayHeaders=false}
+* {csv values=$arObjects displayHeaders=false order=$array separator=$string}
+* or
+* {csv values=$arObjects displayHeaders=false order="field1,field2,..." separator=$string}  
 */
 function smarty_function_csv($params, &$this) {
     extract ($params);
@@ -36,6 +38,7 @@
         $this->_trigger_fatal_error("[plugin CSV] parameter 'values' must be an array");
         return;
     }
+    $output = '';//output init
     //checinkg if value is an array of object or an array of array.
     if (count ($values) <= 0){
         $output = '';
@@ -68,26 +71,39 @@
             $this->_trigger_fatal_error ("[plugin CSV] parameter 'values' must be an array of object or an array of associative array");
         }
     }
+	// processing order ( string case ) 
+    if (isset($order) && is_string($order )){
+	    	$order= explode(',',$order);
+    }
 
     //calculating headers.
     if ($displayHeaders){
-        if ($objectMode){
-            $headers = get_object_vars ($firstRow);
+        if ($objectMode){// we use order if set as header
+            $headers = isset($order) ? $order : get_object_vars ($firstRow);
         }else{
-            $headers = array_key ($firstRow);
+            $headers = isset($order) ? $order : array_keys($firstRow);
         }
         $output .= implode ($separator, $headers)."\n";
     }
 
     //exporting values into csv
     foreach ($values as $rowNumber=>$rowValues) {
-        $rowValues = $objectMode ? array_values (get_object_vars ($rowValues)) : array_values ($rowValues);
+   		$rowValues = $objectMode ? get_object_vars ($rowValues) : $rowValues;
+	    //now sorting elements.
+	    if (isset($order)){
+			if (is_array($order)){
+				$ordered=array();
+				foreach ($order as $key=>$value){
+					$ordered[$key]=$rowValues[$value];
+				}
+				$rowValues=$ordered;
+			} else {
+				$this->_trigger_fatal_error ("[plugin CSV] parameter 'order' must be an array or a string like this : field1,field2...");
+			}
+   		}
         $output .= implode ($separator, $rowValues)."\n";
     }
     
-    //now sorting elements.
-    //TODO.
-
     //processing output
     if (!empty ($assign)){
         $this->assign($assign, $toReturn);
